package com.sample.processserver;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;


import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.base.MapGlobalResolver;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.compiler.BPMN2ProcessFactory;
import org.drools.compiler.ProcessBuilderFactory;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.marshalling.impl.ProcessMarshallerFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessRuntimeFactory;
import org.drools.runtime.process.WorkflowProcessInstance;
import org.jbpm.bpmn2.BPMN2ProcessProviderImpl;
import org.jbpm.marshalling.impl.ProcessMarshallerFactoryServiceImpl;
import org.jbpm.persistence.processinstance.JPAProcessInstanceManager;
import org.jbpm.process.audit.JPAProcessInstanceDbLog;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;
import org.jbpm.process.audit.NodeInstanceLog;
import org.jbpm.process.audit.ProcessInstanceLog;
import org.jbpm.process.audit.VariableInstanceLog;
import org.jbpm.process.builder.ProcessBuilderFactoryServiceImpl;
import org.jbpm.process.instance.ProcessRuntimeFactoryServiceImpl;
import org.jbpm.process.workitem.wsht.CommandBasedWSHumanTaskHandler;
import org.jbpm.process.workitem.wsht.WSHumanTaskHandler;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.ContentData;
import org.jbpm.task.service.responsehandlers.BlockingTaskOperationResponseHandler;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.KnowledgeSessionConfiguration;

import com.sample.poc.CustomerProfile;
import com.sample.processserver.EmailWorkItemHandler;
import com.sample.processserver.SystemOutWorkItemHandler;

import antlr.collections.List;
import bitronix.tm.TransactionManagerServices;
import bitronix.tm.resource.jdbc.PoolingDataSource;

public class TaskProcessServlet extends HttpServlet {

	 private static Log log = LogFactory.getLog(TaskProcessServlet.class);
	 JPAProcessInstanceDbLog  processInstaceLogger;
	 StatefulKnowledgeSession ksession;
	 public void init() throws ServletException {

	        super.init();

	        try {
	        	
	        	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
	            ut.begin();
	             ksession = JbpmAPIUtil.getSession();
	         
	            //JPAWorkingMemoryDbLogger  logger = 
	            	//	new JPAWorkingMemoryDbLogger (ksession);

	        //processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());
	         

		        /*Create the knowledge base  */
		       
				//KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newThreadedFileLogger(ksession, "testlog", 1000);
				CommandBasedWSHumanTaskHandler taskHandler = new CommandBasedWSHumanTaskHandler(ksession);
				ksession.getWorkItemManager().registerWorkItemHandler("Human Task", taskHandler);
				taskHandler.connect();
				ut.commit();
				//logger.dispose();
			//processInstaceLogger.dispose();
			} catch (Throwable t) {
				log.error(t.getMessage(), t.getCause());
				throw new RuntimeException("error while creating session",t);
			}
			
	 }
	 
	 protected void processRequest(HttpServletRequest request, HttpServletResponse response)
	    throws ServletException, IOException {
	        response.setContentType("text/html;charset=UTF-8");
	        PrintWriter out = response.getWriter();

	        try {
	            String action = request.getParameter("action");
	           
	            if (action.equals("CreateProcess")) {
	               
	            	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
		            ut.begin();
	            	
		            new JPAWorkingMemoryDbLogger (ksession);
	            	  
		            KnowledgeRuntimeLoggerFactory.newConsoleLogger(ksession);
	    			
	    			ksession.getWorkItemManager().registerWorkItemHandler("Log", new SystemOutWorkItemHandler());
	                  
	 				 ksession.getWorkItemManager().registerWorkItemHandler(
	 					    "Email", new EmailWorkItemHandler("20.139.68.11","86400","lsundari","Shiva@2012"));	
	 				
	 				//ksession.getWorkItemManager().registerWorkItemHandler("Human Task", new WSHumanTaskHandler());
	 				
	 				CustomerProfile customerProfile = new CustomerProfile(request.getParameter("fName"),request.getParameter("lName"),Integer.parseInt(request.getParameter("age")),Integer.parseInt(request.getParameter("aLimit")),Integer.parseInt(request.getParameter("mSalary")),request.getParameter("eMail"),"TODO","TODO");
	 				Map<String, Object> params = new HashMap<String, Object>();
	 				params.put("customerProfile", customerProfile);
	 				params.put("employee", "lingaiah");
	 				params.put("reason", "CC Review Process");
	 								
	    			
	            	
		          	ksession.startProcess("com.sample.bpmn.creditcardissueprocess",params);	
		          	Thread.sleep(200);      	
					ksession.fireAllRules();
					Thread.sleep(200);
					ut.commit();
					//logger.dispose();
				   
					 request.setAttribute("processVariable", processInstanceVarible());
	                request.setAttribute("message", "Process Created!");
	                request.setAttribute("processList", processInstances());
	                
	                               
	                RequestDispatcher rD = request.getRequestDispatcher("adminuser.jsp");
	                rD.forward(request, response);
	            }
	            else if(action.equals("listtasks")) {
	            	String user = request.getParameter("user");
	            	
	            	//UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
	    			/*
	    			 * Get all the task assigned to 'user'
	    			 */
	                
	    			java.util.List<TaskSummary> tasks = JbpmAPIUtil.getAssignedTasks(user);
	    			TaskSummary task = null;  
	    			
	    		
	    			BlockingTaskOperationResponseHandler responseHandler = null;
	    			ContentData contentData = null;
	    			Map data = new HashMap();
	    			
	    			for (TaskSummary taskSummary : tasks) {   
	    			System.out.println(taskSummary.getId() + " : "     + taskSummary.getActualOwner()); 
	    			}
	    			
	    			request.setAttribute("tasks",tasks);
	    			request.setAttribute("user",user);
	    			
	    			  request.setAttribute("processList", processInstances());
	    			  request.setAttribute("processVariable", processInstanceVarible());
	                RequestDispatcher rD = request.getRequestDispatcher("taskrequest.jsp");
	                rD.forward(request, response);
	    			
	            }
	            
	            else if(action.equals("Submit")) {
	            	
	            	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
	            	 ut.begin();
	            	String user = request.getParameter("user");
	            	/*
	    			 * Get all the task assigned to 'user'
	    			 */
	            	 CustomerProfile data = new CustomerProfile();
	            	 /*data.put("priority",request.getParameter("priority"));
	            	 data.put("modelNumber",request.getParameter("modelNumber"));
	            	 data.put("quantity",request.getParameter("quantity"));*/
	            	 data.setfName(request.getParameter("fName"));
	            	 data.setlName(request.getParameter("lName"));
	            	 data.setAppliedLimit(Integer.parseInt(request.getParameter("aLimit")));
	            	 data.setMonthlySalary(Integer.parseInt(request.getParameter("mSalary")));
	            	 data.seteMail(request.getParameter("eMail"));
	            	 System.out.println("lingarao : "+request.getParameter("reviewStatus"));
	            	data.setReviewStatus(request.getParameter("reviewStatus"));
	            	
	            	  Long processId = new Long((String)request.getParameter("processId"));
	            	//  StatefulKnowledgeSession ksession = JbpmAPIUtil.getSession();
	            	  
	            	 // JPAWorkingMemoryDbLogger  logger = new JPAWorkingMemoryDbLogger (ksession);

	     	       //  processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());
	     	         
	            		WorkflowProcessInstance process = (WorkflowProcessInstance)ksession.getProcessInstance(processId);
	            		((CustomerProfile)process.getVariable("customerProfile")).setReviewStatus(request.getParameter("reviewStatus"));;
	            	   if((request.getParameter("reviewStatus").equalsIgnoreCase("Accepted"))){            		    
	            		((CustomerProfile)process.getVariable("customerProfile")).setCardIssueStatus(" Accepted by manual process , submitted to CC fulfillment process.");
	            	   }else {
	            		   ((CustomerProfile)process.getVariable("customerProfile")).setCardIssueStatus(" Rejeected by manual process , sent status email");
	            	   }
	            	long taskId = new Long(request.getParameter("taskId")).longValue();
	            	String taskStatus = request.getParameter("taskStatus");
	            	
	            	if (!taskStatus.equals("Completed"))
	    			JbpmAPIUtil.completeTask(taskId, data, user);
	    			
	            	//  request.setAttribute("processList", processInstances());
	    			ut.commit();
	    			//logger.dispose();
	    			//processInstaceLogger.dispose();
	    			
	    			//request.setAttribute("tasks",tasks);
	    			 request.setAttribute("processVariable", processInstanceVarible());
	                RequestDispatcher rD = request.getRequestDispatcher("index.jsp");
	                rD.forward(request, response);		
	            }
	            else if(action.equals("taskinit")){
	            	
	            	
	            	request.setAttribute("taskId",request.getParameter("taskId"));
	            	request.setAttribute("taskStatus",request.getParameter("taskStatus"));
	            	request.setAttribute("user",request.getParameter("user"));
	            	request.setAttribute("processId",request.getParameter("processId"));
	            	
	            	 request.setAttribute("processVariable", processInstanceVarible());
	            	//  request.setAttribute("processList", processInstances());
	                RequestDispatcher rD = request.getRequestDispatcher("initialrequest.jsp");
	                rD.forward(request, response);		
	            }
	        } catch(Exception e){
	            out.println("Error:"+ e.getMessage().toString());
	        }
	        finally {
	            out.close();
	        }
	        
	    } 
		 
	 
			 public void destroy() {
				    super.destroy();
				  }

				  protected void doGet(HttpServletRequest request, HttpServletResponse response)
				    throws ServletException, IOException
				  {
					  processRequest(request, response);
				    
				  }

				  protected void doPost(HttpServletRequest request, HttpServletResponse response)
				    throws ServletException, IOException
				  {
					  processRequest(request, response);
				     
				  }
				  
				 private  java.util.List<ProcessInstanceLog> processInstances() {
					 java.util.List<ProcessInstanceLog> list  = new ArrayList<ProcessInstanceLog>();
					  try {
				        	
				        	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
				            ut.begin();
				            StatefulKnowledgeSession ksession = JbpmAPIUtil.getSession();
				         
				            
				            
				            

				         processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());
				         			    
				         			         
				        
				        list    = processInstaceLogger.findProcessInstances("com.sample.bpmn.creditcardissueprocess");//.findActiveProcessInstances("com.sample.bpmn.creditcardissueprocess");

					        /*Create the knowledge base  */
					       
							//KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newThreadedFileLogger(ksession, "testlog", 1000);
							/*CommandBasedWSHumanTaskHandler taskHandler = new CommandBasedWSHumanTaskHandler(ksession);
							ksession.getWorkItemManager().registerWorkItemHandler("Human Task", taskHandler);
							taskHandler.connect();*/
				        ut.commit();
														processInstaceLogger.dispose();
						} catch (Throwable t) {
							log.error(t.getMessage(), t.getCause());
							throw new RuntimeException("error while creating session",t);
						}
					  
					  return list;
						
				 }
				 
				 private  java.util.Map<Long,String> processInstanceVarible() {
					 java.util.Map<Long,String> map  = new HashMap<Long,String> ();
					 
					  try {
				        	
				        	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
				          //  ut.begin();
				            StatefulKnowledgeSession ksession = JbpmAPIUtil.getSession();
				         
				        
				         processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());
				         java.util.List<ProcessInstanceLog> list  = new ArrayList<ProcessInstanceLog>();
				         
		          
				        			         
				         list    = processInstaceLogger.findProcessInstances("com.sample.bpmn.creditcardissueprocess");
				         for(int i =0 ; i < list.size() ; i++) { 
				        	 
				        	 System.out.println(processInstaceLogger.findVariableInstances(list.get(i).getId(),"customerProfile"));
				        	 
				        	 map.put(Long.valueOf(list.get(i).getProcessInstanceId()), processInstaceLogger.findVariableInstances(list.get(i).getProcessInstanceId(),"customerProfile").get(0).getValue());
			                }
				      //   list    = processInstaceLogger.findActiveProcessInstances("com.sample.bpmn.creditcardissueprocess");

				         
				        
							
							
							//ut.commit();
							//processInstaceLogger.dispose();
						} catch (Throwable t) {
							log.error(t.getMessage(), t.getCause());
							throw new RuntimeException("error while creating session",t);
						}
					  
					  return map;
						
				 }
				 
				 
				 private  java.util.List<NodeInstanceLog> processNodeInstance(long processInstanceId) {
					 java.util.List<NodeInstanceLog> list  = new ArrayList<NodeInstanceLog>();
					  try {
				        	
				        	UserTransaction ut = (UserTransaction) new InitialContext().lookup( "java:comp/UserTransaction" );
				            ut.begin();
				            StatefulKnowledgeSession ksession = JbpmAPIUtil.getSession();
				         
				          

				         processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());
				         
				       	         
				         
				         list    = processInstaceLogger.findNodeInstances(processInstanceId);
				      //   list    = processInstaceLogger.findActiveProcessInstances("com.sample.bpmn.creditcardissueprocess");

					        /*Create the knowledge base  */
					       
							//KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newThreadedFileLogger(ksession, "testlog", 1000);
							
							ut.commit();
							
							processInstaceLogger.dispose();
						} catch (Throwable t) {
							log.error(t.getMessage(), t.getCause());
							throw new RuntimeException("error while creating session",t);
						}
					  
					  return list;
						
				 }
}
